<!DOCTYPE html>
<html lang="en">
{% load static %}

<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>app</title>
    <link rel="manifest" href="{% static 'manifest.webmanifest' %}">
    <link href="https://fonts.googleapis.com/css2?family=Ubuntu:wght@500&display=swap" rel="stylesheet">
    <link rel="stylesheet" href="{% static 'css/style.css' %}">
</head>

<body>

    <header class="main-nav">
        <ul>
            <li>
                <a href="/">
                    صفحه اصلی
                </a>
            </li>
            <li>
                <a href="/filtered">
                    صفحه اختصاصی
                </a>
            </li>
        </ul>
        <img src="{% static 'images/logo.png' %}" alt="">
    </header>
    <div class="wrapper">
        <div class="filter-wrapper">
            <div>
                <label for="percent">حداقل درصد سود</label>
                <input type="number" value=0 name="percent">

            </div>
            <div>
                <label for="pricefilter">حداقل قیمت مورد بررسی</label>
                <input type="number" value=0 name="pricefilter">

            </div>
            <button class="filter">شروع</button>
            <button class="clearFilter">پایان</button>

        </div>

        <table>
            <thead>
                <tr>
                    <th>rank</th>
                    <th>Pair</th>
                    <th>last price</th>
                    <th>24hr change</th>
                </tr>
            </thead>
            <tbody>


            </tbody>
        </table>
    </div>
    <div class="container"></div>
    <script src="{% static 'js/jquery-1.12.4.min.js' %}"></script>
    <script src="{% static 'js/push.min.js' %}"></script>
    <script>
        $(document).ready(function () {

            $('.click').click(function () {
                Push.create('Hello world!', {
                    body: 'How\'s it hangin\'?',
                    icon: '/images/icon.png',
                    link: '/#',
                    timeout: 4000,
                    onClick: function () {
                        console.log("Fired!");
                        window.focus();
                        this.close();
                    },
                    vibrate: [200, 100, 200, 100, 200, 100, 200]
                });
            })
            if (localStorage.getItem('percent')) {
                $('.filter-wrapper button.filter').hide();
                $('.filter-wrapper button.clearFilter').show();
            } else {
                $('.filter-wrapper button.filter').show();
                $('.filter-wrapper button.clearFilter').hide();
            }
            function findWithAttr(array, attr, value) {
                for (var i = 0; i < array.length; i += 1) {
                    if (array[i][attr] === value) {
                        return i;
                    }
                }
                return -1;
            }
            var getdata = function (percent, pricefilter) {
                $.ajax({
                    type: 'GET',
                    url: 'https://api.binance.com/api/v3/ticker/24hr',
                    dataType: 'json',
                    success: function (data) {
                        var startArray = data.filter(function (el) {
                            return el.symbol.indexOf('BTC') != -1 || el.symbol.indexOf('USDT')
                        })
                        startArray.sort(function (a, b) {
                            return b.priceChangePercent - a.priceChangePercent;
                        });
                        if (localStorage.getItem('startArray') == null) {

                            localStorage.setItem('startArray', JSON.stringify(startArray));
                        }
                        var reached = [];
                        var interval = setInterval(function () {
                            var notification_msg = ""
                            $.ajax({
                                type: 'GET',
                                url: 'https://api.binance.com/api/v3/ticker/24hr',
                                dataType: 'json',
                                success: function (data) {


                                    if (pricefilter) {
                                        var realtime = data.filter(function (el) {
                                            return el.symbol.indexOf('BTC') != -1 || el.symbol.indexOf('USDT') != -1 & el.lastPrice > pricefilter
                                        })
                                    } else {
                                        var realtime = data.filter(function (el) {
                                            return el.symbol.indexOf('BTC') != -1 || el.symbol.indexOf('USDT') != -1
                                        })
                                    }
                                    $.each(realtime, function (i, d) {
                                        var filtered = JSON.parse(localStorage.getItem('startArray')).filter(function (el) {
                                            return el.symbol == d.symbol
                                        })
                                        if (filtered.length > 0) {
                                            var differ = parseFloat(d.priceChangePercent) - parseFloat(filtered[0].priceChangePercent)
                                        }
                                        d.differ = differ

                                        var index = reached.indexOf(d.symbol)
                                        if (index == -1) {
                                            if (differ > percent) {
                                                notification_msg += d.symbol + " +" + Math.round(differ * 100) / 100 + "% "
                                                reached.push(d.symbol);
                                                console.log(notification_msg)
                                                Push.create('hey', {
                                                    body: notification_msg,
                                                    link: '/',
                                                    timeout: 4000,
                                                    onClick: function () {
                                                        console.log("Fired!");
                                                        window.focus();
                                                        // this.close();
                                                    },
                                                    vibrate: [200, 100, 200, 100, 200, 100, 200]
                                                });
                                            }
                                        } else {
                                            if (differ <= percent) {
                                                reached.splice(index, 1)

                                            }
                                        }

                                    });



                                    $.each(realtime, function (i, d) {
                                        var name = d.symbol;
                                        if (localStorage.getItem(name) != null) {
                                            var array = JSON.parse(localStorage.getItem(name));
                                            array.push(d.priceChangePercent)
                                        } else {
                                            var array = [d.priceChangePercent]
                                        }
                                        if (array.length == count) {
                                            var sum = 0;
                                            $.each(array, function (i, d) {
                                                sum += d;
                                                average = sum / array.length
                                            })
                                        }
                                        if (array.length > 3) {
                                            array.shift()
                                        }
                                        localStorage.setItem(name, JSON.stringify(array))
                                    })



                                    // console.log(realtime)
                                    realtime.sort(function (a, b) {
                                        return b.differ - a.differ;
                                    });
                                    $('.wrapper tbody').html('')
                                    $.each(realtime, function (i, d) {
                                        // rankChange = findWithAttr(JSON.parse(localStorage.getItem('startArray')), 'symbol', d.symbol) - i

                                        var color = d.differ <= 0 ? "red" : "green"
                                        var row_color = ""
                                        var rank_sign = ""
                                        if (d.differ > 0 && d.differ < 3) {
                                            row_color = "yellow"
                                            rank_sign = '<i class="arrow up"></i>'
                                        } else if (d.differ > 2 && d.differ < 6) {
                                            row_color = "lightgreen"
                                            rank_sign = '<i class="arrow up"></i>'
                                        } else if (d.differ > 5 && d.differ < 9) {
                                            row_color = "darkgreen"
                                            rank_sign = '<i class="arrow up"></i>'
                                        } else if (d.differ > 8 && d.differ < 12) {
                                            row_color = "purple"
                                            rank_sign = '<i class="arrow up"></i>'
                                        } else if (d.differ > 11 && d.differ < 15) {
                                            row_color = "darkpurple"
                                            rank_sign = '<i class="arrow up"></i>'
                                        } else if (d.differ > 14 && d.differ < 18) {
                                            row_color = "brown"
                                            rank_sign = '<i class="arrow up"></i>'
                                        } else if (d.differ > 17) {
                                            row_color = "black"
                                            rank_sign = '<i class="arrow up"></i>'
                                        } else if (d.differ < 0) {
                                            rank_sign = '<i class="arrow down"></i>'
                                        }
                                        var symbol = ""
                                        if (d.symbol == "BTCUSDT") {
                                            symbol = "BTC/USDT"
                                        } else if (d.symbol.startsWith('BTC') || d.symbol.endsWith('BTC')) {
                                            var splitted = d.symbol.split('BTC'); //this will output ["1234", "56789"]
                                            var first = splitted[0]; //"1234"
                                            var second = splitted[1]; //"56789"
                                            if (first != "") {
                                                symbol = "<span>" + first + "</span> / <span>BTC</span>"
                                            } else if (second != "") {
                                                symbol = "</span> <span>BTC</span> / <span>" + second + "</span>"
                                            }
                                        } else if (d.symbol.startsWith('USDT') || d.symbol.endsWith('USDT')) {

                                            var splitted = d.symbol.split('USDT'); //this will output ["1234", "56789"]
                                            var first = splitted[0]; //"1234"
                                            var second = splitted[1]; //"56789"
                                            if (first != "") {
                                                symbol = "<span>" + first + "</span> / <span>USDT</span>"
                                            } else if (second != "") {
                                                symbol = "</span> <span>USDT</span> / <span>" + second + "</span>"
                                            }
                                        }
                                        $('.wrapper tbody').append('<tr class=' + row_color + '><td>' + (i + 1) + '</td><td class="symbol">' + rank_sign + ' ' + symbol + '</td><td>' + (Math.round(d.lastPrice * 10000000) / 10000000).toString() + '</td><td class="td-flex"><span class=' + color + '>' + Math.round(d.differ * 10000000) / 10000000 + '%' + '</span></td></tr>')
                                    })
                                },
                                error: function () {
                                    console.log('Ajax request failed...');
                                    setTimeout(function () { getdata() }, $.ajaxSetup().retryAfter);
                                }
                            })
                        }, 3000);
                        $('.clearFilter').click(function () {
                            $(".wrapper tbody").html("")
                            clearInterval(interval)
                            localStorage.clear()
                            interval = null;
                            $('.filter-wrapper button.filter').show();
                            $('.filter-wrapper button.clearFilter').hide();
                        })
                    }
                })

            }


            $('.filter').click(function () {
                $('.wrapper tbody').html('<tr><td colspan="4">plz wait...</td></tr>')
                percent = $('input[name="percent"]').val()
                pricefilter = $('input[name="pricefilter"]').val()
                localStorage.setItem('pricefilter', JSON.stringify(pricefilter))
                localStorage.setItem('percent', JSON.stringify(percent))
                getdata(percent, pricefilter)
                $('.filter-wrapper button.filter').hide();
                $('.filter-wrapper button.clearFilter').show();
            })
            if (localStorage.getItem('percent') != null) {
                percent = JSON.parse(localStorage.getItem('percent'))
                pricefilter = JSON.parse(localStorage.getItem('pricefilter'))
                getdata(percent, pricefilter)
                $('input[name="percent"]').val(percent)
                $('input[name="pricefilter"]').val(pricefilter)
            }
        })


    </script>
</body>

</html>